from xml.dom import minidom
import bpy
import math
import mathutils
#from bpy import *
#import sys,os
from bpy.props import *

#GLOBALNE PREMENNE
scn = bpy.context.scene
global_koef = 6 #koeficient, ktorym prenasobim beaty resp. bary #zvacsujem nim vzdialenosti keyframeov
beats_in_one_bar = 4
bar = -1
beat = 0
armature = None #kostra ktoru oznacim
positions = dict()  #tu si pamatam pozicie z position.xml
intermediate_positions = dict()  #tu si pamatam MEDZIpozicie z intermediate_position.xml
animation_shifting = 0 #posunutie animacie
support_keyframes = []
arm_l_keyframes = []
arm_r_keyframes = []
 
 
def deleteKeyFrames(first, last):   #zmazanie existujucich keyframeov od first po last
  #k = bpy.context.scene.frame_current = 0
  bpy.context.scene.frame_set(first-1)
  bpy.ops.screen.keyframe_jump()
  next2 = bpy.context.scene.frame_current
  next1 = next2 - 1
  while next1!=next2 and next2<=last:
    bpy.ops.anim.keyframe_delete_v3d()
    next1 = next2
    bpy.ops.screen.keyframe_jump()
    next2 = bpy.context.scene.frame_current
   
  global support_keyframes
  global arm_l_keyframes
  global arm_r_keyframes
    
  support_keyframes = []
  arm_l_keyframes = []
  arm_r_keyframes = [] 
    
  bpy.context.scene.frame_set(0)
  

def old_deleteKeyFrames(first, last):   #zmazanie existujucich keyframeov od first po last
  #k = bpy.context.scene.frame_current = 0
  for i in range(first, last+1):
    bpy.context.scene.frame_current = i
    bpy.ops.anim.keyframe_delete_v3d()
  bpy.context.scene.frame_current = 0
  
   
def clear_location_on_armature(armName): #vymazem rotacie na kostre
  try:
    for b in bpy.data.armatures[armName].bones:
      b.select = True
    bpy.ops.pose.loc_clear()
  except Exception as e:
    print(e)
  
  
def vector_from_string(string_vector):     #string tvaru (cislo, cislo, cislo); vrati mathutils.Vector
  vec_string = string_vector
  arr0 = vec_string.replace('(','') 
  arr = arr0.replace(')','')
  #print(arr)
  vec_array = []; #prazdne pole
  vec_array_string = arr.rsplit(',')
  for v in vec_array_string:
    try:
      v = float(v)
      vec_array.append(v)
    except:
      print('Exception: Value can\'t be float!')
      return None;
  my_Vec = mathutils.Vector( (vec_array[0],vec_array[1],vec_array[2]) )                                          
  #print(my_Vec)
  return my_Vec
  
############################################################################
### START nacitavanie pozicii
############################################################################
def save_positions_to_structure(_positions_doc):  #to dictionary
  database = _positions_doc.getElementsByTagName("database")
  elements = database[0].childNodes
  el = dict()
  for element_n in elements:
    if element_n.nodeType == element_n.ELEMENT_NODE:
      #print(element_n.nodeName)
      direction_nodes = element_n.childNodes
      direction = dict()
      for direction_nodes_n in direction_nodes:
        if direction_nodes_n.nodeType == direction_nodes_n.ELEMENT_NODE:
          #print(direction_nodes_n.nodeName)
          level_nodes = direction_nodes_n.childNodes
          level = dict()
          for level_nodes_n in level_nodes:
            if level_nodes_n.nodeType == level_nodes_n.ELEMENT_NODE:
              #print(level_nodes_n.nodeName)
              bodyparts = level_nodes_n.childNodes
              bodyp = dict()
              for bodyparts_n in bodyparts:
                if bodyparts_n.nodeType == bodyparts_n.ELEMENT_NODE:
                  #print(bodyparts_n.nodeName)
                  #print(bodyparts_n.firstChild.data) #takto dostanem text z element
                  m = vector_from_string(bodyparts_n.firstChild.data)
                  bodyp[bodyparts_n.nodeName] = m
              level[level_nodes_n.nodeName] = bodyp
          direction[direction_nodes_n.nodeName] = level
      el[element_n.nodeName] = direction
      #print(el['Arm_R']['Right']['M']['Rameno_R'])
      #print(el['Arm_R']['Right']['M']['Predlaktie_R'])
      #print(el['Arm_R']['Right']['M']['Ruka_R'])
  #global positions
  #positions = dict(el)
  #print ('VALUES:', positions.values)
  return el
                  
                  
def load_positions_from_xml(position_file):
  try:                
    positions_doc = minidom.parse(position_file)
    print ('Success load positions XML file with name:', position_file) 
  except:
    print ('Can\'t parse position XML filewith name:', position_file)
    return 
    
  return save_positions_to_structure(positions_doc)  #vrati slovnik s definovanymi poziciami
############################################################################
### END nacitavanie pozicii
############################################################################


############################################################################
### START PARSOVANIE
############################################################################
def parse_support_nodes(_armature, _support_nodes, _bar):
  global beat
  global beats_in_one_bar
  beat = 0
  print('parse_support_function')
  
  support_dict = dict() # vtomto slovniku si ulozimcelu cast support a potom ju vcelku vyhodnotim
  
  #p = {'Support_L':dict(), 'Support_R':dict(), 'Support_RL':dict()}
  for i in range(1, beats_in_one_bar+1):
    #support_dict[i] = dict( {'Support_L':dict(), 'Support_R':dict(), 'Support_RL':dict()} )
    support_dict[i] = dict( {'Support_L':dict(), 'Support_R':dict()} )
  
  for sn in _support_nodes:
    side_dict = dict()
    p = dict()
    try:  
      ticknum = int(sn.attributes["ticknum"].value) #prejdem atributy bodyp (urcuju cas)
      beat = ticknum
    except:
      print('Attributte \'ticknum\' is missing or should be a natural number!')
      beat = beat + 1
    
      
    duration = 0
    try:
      duration = int(sn.attributes["duration"].value)-1
    except Exception as e:
      #print (e)
      print('Not found attribute \'duration\' or value of attribute is not natural number!')
      
    #global scn 
    if _bar==0: 
      cur_frame = -animation_shifting + global_koef*(beats_in_one_bar*(_bar + 1))#scn.frame_current = global_koef*(beats_in_one_bar*_bar + 4) #zaciatok
    else:
      cur_frame = -animation_shifting + global_koef*(beats_in_one_bar*_bar + beat + duration) #scn.frame_current = global_koef*(beats_in_one_bar*_bar + beat) #global_koef*beats_in_one_bar*_bar + global_koef*beat #posuniem sa na pozadovany frame
      
      
    side = ''
    try:  
      side = sn.attributes["side"].value
    except:
      print('Attributte \'side\' is missing or should be a string!')
    
    pos = 'Support_R_L' #ak side=='' tak obe strany  
    if side=='right':
      pos = 'Support_R'
    if side=='left':
      pos = 'Support_L'
    
    symbols = sn.childNodes
    direction = ""
    level = ""
    for symbol in symbols:
      if symbol.nodeName == 'direction':
        direction = symbol.firstChild.data #takto dostanem text z elementu
        #print(direction)
      if symbol.nodeName == 'level':
        level = symbol.firstChild.data #takto dostanem text z elementu
        #print(level)
          
    #ulozim do support dictionary aby som potom mohol aplikovat ako celok
    side_dict = {'direction':direction, 'level':level, 'duration':duration, 'frame':cur_frame}
    if pos == 'Support_R_L':
      support_dict[beat]['Support_L'] = side_dict
      support_dict[beat]['Support_R'] = side_dict
    else:
      support_dict[beat][pos] = side_dict
  
  #mam ulozene vsetky supporty v support_dict, tak mozem aplikovat:
  apply_supports(support_dict, _armature)
  
  print('SUPPORT_DICT:', support_dict)
  support_dict.clear() #ked prejdem vsetky supporty, tak ho vymazem aby som ho v dalsom bare mohol opat naplnit            
 


def apply_supports(_support_dict, _armature):
  global scn
  global beats_in_one_bar
  global support_keyframes
  for b in _support_dict.keys():
    try:
      if _support_dict[b]['Support_R']!={} and _support_dict[b]['Support_L']!={}: #pre positions_ik03.xml
        print('apply Support')
        direct = _support_dict[b]['Support_R']['direction'] + '_' + _support_dict[b]['Support_L']['direction']
        lev = _support_dict[b]['Support_R']['level'] + '_' + _support_dict[b]['Support_L']['level']
        dur = int(_support_dict[b]['Support_R']['duration']) # v tomto pripade by duration malo byt rovnake, lebo inak by ten zapis nemal zmysel
        c_f = int(_support_dict[b]['Support_R']['frame'])
        scn.frame_set(c_f)
        try:
          for i in positions['Support'][direct][lev].keys():  #prechadzam kosti v databaze
            _armature.pose.bones[i].location = positions['Support'][direct][lev][i]  #priradim maticu z positions databazy
          bpy.ops.anim.keyframe_insert_menu(type='Location')
          support_keyframes.append(scn.frame_current)
        except Exception as e1:
          print ('Nepodarilo sa priradit LOKACIU', e1)
            
      else: #obsahuje len Support_R alebo Support_L, tak pokojne mozem pouzit positions
        if _support_dict[b]['Support_R']!={}:
          print('MA SUPPORT R')
          posit = 'Support_R'
        if _support_dict[b]['Support_L']!={}:
          print('MA SUPPORT L')
          posit = 'Support_L'
          
        if _support_dict[b]['Support_R']!={} or _support_dict[b]['Support_L']!={}:
          direct = _support_dict[b][posit]['direction']
          lev = _support_dict[b][posit]['level']
          dur = int(_support_dict[b][posit]['duration'])
          c_f = int(_support_dict[b][posit]['frame'])
          scn.frame_set(c_f)
          try:    
            #prechadzame kosti v databaze
            for i in positions[posit][direct][lev].keys():
              #priradime maticu z positions databazy
              _armature.pose.bones[i].location = positions[posit][direct][lev][i]
            bpy.ops.anim.keyframe_insert_menu(type='Location')
            support_keyframes.append(scn.frame_current)
          except Exception as e1:
            print ('Couldn\'t set location:', e1)
        else:
          print('Support is empty in beat', b)
    except Exception as e:
      print ('print Exception', e)
      
  
def parse_right_or_left(_armature, right_or_left_node, _bar):
  global beat
  global beats_in_one_bar
  global arm_l_keyframes
  global arm_r_keyframes
  beat = 0
  print('parse_right_or_left_function for:', right_or_left_node.nodeName )
  bodyps = right_or_left_node.childNodes
  for bodyp in bodyps:
    if bodyp.nodeType == bodyp.ELEMENT_NODE:
      #moved_bone_name = ''      
      pos = ''
      if right_or_left_node.nodeName == 'right':
        if bodyp.nodeName == 'hand': #zapamatam si, ze do ktorej casti v positions sa chcem dostat
          pos = 'Hand_R'
        if bodyp.nodeName == 'arm':
          pos = 'Arm_R'
      if right_or_left_node.nodeName == 'left':
        if bodyp.nodeName == 'hand': #zapamatam si, ze do ktorej casti v positions sa chcem dostat
          pos = 'Hand_L'
        if bodyp.nodeName == 'arm':
          pos = 'Arm_L'
        
        
      try:  
        ticknum = int(bodyp.attributes["ticknum"].value) #prejdem atributy bodyp (urcuju cas)
        beat = ticknum
      except:
        print('Attributte \'ticknum\' is missing or should be a natural number!')
        beat = beat + 1
      
      duration = 0
      try:
        duration = int(bodyp.attributes["duration"].value)-1
      except Exception as e:
        #print (e)
        print('Not found attribute \'duration\' or value of attribute is not natural number!')
      #for bodyp_att in bodyp_attributes:
       # print(bodyp_att)
      
      global scn 
      if _bar==0: 
        scn.frame_set(-animation_shifting + global_koef*(beats_in_one_bar*(_bar + 1)))#scn.frame_current = global_koef*(beats_in_one_bar*_bar + 4) #zaciatok
      else:
        scn.frame_set(-animation_shifting + global_koef*(beats_in_one_bar*_bar + beat + duration)) #global_koef*beats_in_one_bar*_bar + global_koef*beat #posuniem sa na pozadovany frame
     
      #print('Frame_current:') 
      #print(scn.frame_current)
        
      symbols = bodyp.childNodes #prejdem elementy v bodyp(urcuju ako sa ma kost hybat)
      direction = ""
      level = ""
      for symbol in symbols:
        if symbol.nodeName == 'direction':
          direction = symbol.firstChild.data #takto dostanem text z elementu
          #print(direction)
        if symbol.nodeName == 'level':
          level = symbol.firstChild.data #takto dostanem text z elementu
          #print(level)
      
      #aplikovanie pozy z databazy
      try:
        global positions
        #print('KEYS:',positions[pos][direction][level].keys())
        for i in positions[pos][direction][level].keys():
          _armature.pose.bones[i].location = positions[pos][direction][level][i]
          #print(positions[pos][direction][level][i])
        bpy.ops.anim.keyframe_insert_menu(type='Location')
        if pos == 'Arm_L':
          arm_l_keyframes.append(scn.frame_current)
        if pos == 'Arm_R':
          arm_r_keyframes.append(scn.frame_current)
      except Exception as e:
        print('Print Exception(right_or_left_functiona):', e)


def parse_measure_element(_armature, measure_node):
  global bar
  global beats_in_one_bar
  #print('parse_MEASURE func')
  #print(num.value)
  try:
    num = measure_node.attributes["num"]
    val = int(num.value)
    bar = val
  except:
    print('Attributte \'num\' is missing or should be a natural number!')
    bar = bar + 1 #ak nie je atribut 'num', tak sa posuniem o jeden bar dalej
  print('-----------------------------------')
  print('BAR:', bar)

  global scn
  scn.frame_set(-animation_shifting + global_koef*beats_in_one_bar*bar)#scn.frame_current = global_koef*beats_in_one_bar*bar #posuniem sa na pozadovany frame
  #cur_frame = scn.frame_current
  
  #print(scn.frame_current)
   
  element_nodes = measure_node.childNodes
  #print (element_nodes.nodeName)
  support_nodes = []
  for node in element_nodes:
    if node.nodeType == node.ELEMENT_NODE:
      #print(node.nodeName)
      if node.nodeName=="support":
        #parse_support(_armature, node, bar)
        support_nodes.append(node)#len pridam elementy, aby som to potom mohol vyhodnotit ako celok
      if node.nodeName=="left": 
        parse_right_or_left(_armature, node, bar)
      if node.nodeName=="right":
        parse_right_or_left(_armature, node, bar)   
        
  if support_nodes != []:
    parse_support_nodes(_armature, support_nodes, bar) #nakoniec parsujem support nodey, lebo ich potrebujem vyhodnotit sucasne
  else:
    print ('Support nodes are empty in bar', bar)


def parse_repeat_element(_armature, repeat_node):
  #print('parse_REPEAT func')
  try:
    times = int(repeat_node.attributes["times"].value)
  except:
    print('Attribute \'times\' is not natural number')
    times = 1  
  #print(times)
  measures_in_repeat = repeat_node.childNodes
  for i in range(0,times):
    for m_in_repeat in measures_in_repeat:
      if m_in_repeat.nodeType == m_in_repeat.ELEMENT_NODE:     
        parse_measure_element(_armature, m_in_repeat)
    

def parse_document(_armature, document):
  global beats_in_one_bar
  doc = document
  
  #tu este nacitanie <beat> a <beat-type> a priradenie do koeficientov
  b = doc.getElementsByTagName("beat")
  beats_in_one_bar = int(b[0].firstChild.data) 
  print("BEATS_IN_ONE_BAR:", beats_in_one_bar)
  
  global animation_shifting
  animation_shifting = global_koef * beats_in_one_bar - scn['MyStartFrame']
  
  notation_node_list = doc.getElementsByTagName("notation") #vrati vsetky elementy <measure>(aj ked nie su priamo potomkami elementu <notation>, aj vnorene vrati)
  node_list = notation_node_list[0].childNodes
  for node_list_n in node_list:
    #element_n = measure_node_list[i]
    if (node_list_n.nodeType == node_list_n.ELEMENT_NODE):
      #print(node_list_n.nodeName)
      if (node_list_n.nodeName == 'measure'):
        parse_measure_element(_armature, node_list_n)
      if (node_list_n.nodeName == 'repeat'):
        parse_repeat_element(_armature, node_list_n)
############################################################################
### END PARSOVANIE
############################################################################ 
        
def is_changed_posebone_position(poseBone, frameFirst, frameSecond):
  global scn
  scn.frame_set(frameFirst)
  location_first = poseBone.location #lokacia kosti vo frame frame_first
  #print (poseBone.matrix)
  #print (matrix_first)
  scn.frame_set(frameSecond)
  location_second = poseBone.location #matica kosti v o frame frame_second
  #print (matrix_second)
  
  #print (poseBone.name)
  if location_first != location_second:
    print ("Pohyb kosti:", poseBone.name)
    return True
  else:
    print ('Nie je pohyb kosti:', poseBone.name)
    return False
  
  scn.frame_set(frameFirst)
  

def compare_locations(location_first, location_second, tolerance_vector): 
  if location_first == None or location_first == None:
    print('Empty location vector!')
    return False
    
  #print('LOCATION_FIRST:', location_first, 'LOCATION_SECOND:', location_second)
  if (abs(location_first.x - location_second.x) > tolerance_vector.x):
    return False
  if (abs(location_first.y - location_second.y) > tolerance_vector.y):
    return False
  if (abs(location_first.z - location_second.z) > tolerance_vector.z):
    return False
      
  return True
  

def find_location_in_dictionary_for_bone(_location_vector, _dictionary, _bone): #vrati list(zoznam) stringov, ktore oznacuju poziciu
  compare_vector = mathutils.Vector((0.01, 0.01, 0.01))
  my_l = list()
  for bodyp in _dictionary.keys():
    #print(m)
    for direct in _dictionary[bodyp].keys():
      #print(direct)
      for level in _dictionary[bodyp][direct].keys():
        #print(level)
        for b in _dictionary[bodyp][direct][level].keys():
          #print(b)
          if b == _bone.name:
            #print(_dictionary[bodyp][direct][level][b])
            if _dictionary[bodyp][direct][level][b] != None:
              #print('CCCC:', _dictionary[bodyp][direct][level][b])
              try:
                m1 = _dictionary[bodyp][direct][level][b]
                m2 = _location_vector
                #print (m1)
                #print (m2) 
                if compare_locations(m1, m2, compare_vector):    
                  my_l.append('bodypart=' + str(bodyp) + ';direction=' + str(direct) + ';level=' + str(level))
              except Exception as e:
                print('Find_location_problem:', e)
                  
  return my_l


def find_position_for_bones_list(list_of_bone, in_frame, _arm): #vrati string v tare "bodypart=Support_R;direction=Right;level=L"
  global scn
  global positions
  scn.frame_set(in_frame)
  dict_of_bones_location_lists = dict()
  for b in list_of_bone: #vytvorim si slovnik , v ktorom budu ulozene zoznamy(listy) s prislusnymi stringami moznych pozicii
    p_bone = _arm.pose.bones[b]
    loc_vec = p_bone.location.copy()
    #print('LOC VEC:', loc_vec, 'P_BONE:', p_bone)
    dict_of_bones_location_lists[b] = find_location_in_dictionary_for_bone(loc_vec, positions, p_bone)
  
  #prejdem cely slovnik a ktora pozicia sa bude vyskytovat najcastejsie, tak ta bude vysledna
  #najprv si pocty vyskytov ulozim do slovnika
  counter = dict()
  #print('LIST:', dict_of_bones_location_lists.keys())
  for bonename in dict_of_bones_location_lists.keys():
    for s in dict_of_bones_location_lists[bonename]:
      #print(s)
      if counter=={}:
        counter[s] = 1
      else:
        if s in counter.keys():
          old = counter[s]
          new = old + 1
          counter[s] = new
        else:
          counter[s] = 1
  
  #print('COUNTER:', counter)      
  #najdem maximalnu hodnotu v counter slovniku
  max_val = 0
  max_key = '?'
  for c in counter.keys():
    #print('COUNTER[c]:', counter[c])
    if counter[c] > max_val:
      max_val = counter[c]
      max_key = c
  
  print('MAX_KEY:', max_key)
  print('MAX_VAL:', max_val)
  counter.clear()    
  return {'max_key': max_key, 'max_val': max_val}
  
  
def make_dictionary_from_my_string(my_string): #vrati slovnik z my_stringu
  ret_dict = dict()
  if my_string=='?':
    return ret_dict
    
  arr = my_string.rsplit(';')
  if len(arr) == 3:
    for i in range(0,3):
      arri = arr[i].rsplit('=')
      ret_dict[arri[0]] = arri[1]
    
  return ret_dict
       


def refill_position_between_two_positions(frameFirst, frameSecond, _armature):
  global scn
  scn.frame_set(frameFirst)
  controll_bone_list = [['Pivot_ruka_R'], ['Pivot_ruka_L'], ['Pivot_noha_R', 'Pivot_noha_L', 'Pivot_noha_prsty_R', 'Pivot_noha_prsty_L', 'Chrbtica1']]
  for bonelist in controll_bone_list:
    scn.frame_set(frameFirst)
    one_string = find_position_for_bones_list(bonelist, frameFirst, _armature)['max_key']
    #print('ONE_STRING', one_string)
    one = make_dictionary_from_my_string(one_string) #slovnik parametrov pre poziciu
    
    scn.frame_set(frameSecond)
    two_string = find_position_for_bones_list(bonelist, frameSecond, _armature)['max_key']
    #print('TWO_STRING', two_string)
    two = make_dictionary_from_my_string(two_string) #slovnik parametrov pre poziciu
    
    middleFrame = frameFirst + ((frameSecond - frameFirst)/2)
    print('MIDDLE FRAME:', middleFrame)  
    if one!={} and two!={}:
      global intermediate_positions
      scn.frame_set(middleFrame)
      if one == two: #ak rovnake  dve pozicie, tak medzi ne pridam taku istu(teor. nemusi byt)
        try:
          for i in positions[one['bodypart']][one['direction']][one['level']].keys():
            _armature.pose.bones[i].location = positions[one['bodypart']][one['direction']][one['level']][i]   
          bpy.ops.anim.keyframe_insert_menu(type='Location')
        except Exception as e:
          print('Refill intermediate positions:', e)
      else: #ak nie su rovnake, tak priradim medzipoziciu z intermeidate_positions
        pos = one['bodypart'] + '_' + two['bodypart']
        direction = one['direction'] + '_' + two['direction']
        level = one['level'] + '_' + two['level']
        print('MID-POS:', pos, 'DIRECTION:', direction, 'LEVEL:', level)
        try:
          for i in intermediate_positions[pos][direction][level].keys():
            _armature.pose.bones[i].location = intermediate_positions[pos][direction][level][i]   
          bpy.ops.anim.keyframe_insert_menu(type='Location')
        except Exception as e:
          print('Refill intermediate positions:', e)
    else:
      if one=={}:
        print('Can\'t find location for', bonelist, 'in frame', frameFirst)
      if two=={}:
        print('Can\'t find location for', bonelist, 'in frame', frameSecond)
    
    scn.frame_set(frameSecond) #musi byt lebo potom problem s keyFrame_jump v refill_all_...

    #print (one['bodypart'], one['direction'], one['level'])
    #print (two['bodypart'], two['direction'], two['level'])
    
    
#tato fcia nedoplni medzipolohu len medzi dvoma susednymi Keyframeami
#sluzi na to, zby sme dokazali doplnit polohu aj pre pohyb, ktoreho trvanie je viac ako len vzdialenost dvoch Keyframeov    
def refill_position_for_bonelist(_fromFrame, _toFrame, _bonelist, _armature):
  global scn
  scn.frame_set(_fromFrame)
  next2 = scn.frame_current
  next1 = next2-1
  loc_dict = find_position_for_bones_list(_bonelist, _fromFrame, _armature)
  if loc_dict['max_val']==len(_bonelist): #ak sme nasli naozaj presnu poziciu 
    one_string = loc_dict['max_key']
    one = make_dictionary_from_my_string(one_string) #slovnik parametrov pre poziciu
    #zacneme hladat dalsiu presnu poziciu, aby sme medzi nimi vytvorili medzipolohu
    bpy.ops.screen.keyframe_jump()
    next1 = next2
    next2 = scn.frame_current
    help_val = 0
    #ct = 0
    while help_val!=len(_bonelist) and scn.frame_current<=_toFrame and next1!=next2: #tzn. kym nenajdem dalsiu "presnu" poziciu = poziciu z databazy
      #ct=ct+1
      _help = find_position_for_bones_list(_bonelist, scn.frame_current, _armature) 
      help_val = _help['max_val']
      if help_val==len(_bonelist):#nasiel som "presnu" poziciu
        middleFrame = _fromFrame + ((scn.frame_current - _fromFrame)/2)
        print('MIDDLE FRAME:', middleFrame)
        scn.frame_set(middleFrame)
        
        global intermediate_positions
        two = make_dictionary_from_my_string(_help['max_key'])
        pos = one['bodypart'] + '_' + two['bodypart']
        direction = one['direction'] + '_' + two['direction']
        level = one['level'] + '_' + two['level']
        print('MID-POS:', pos, 'DIRECTION:', direction, 'LEVEL:', level , 'BONELIST:', _bonelist)
        try:
          for i in intermediate_positions[pos][direction][level].keys():
            _armature.pose.bones[i].location = intermediate_positions[pos][direction][level][i]   
          bpy.ops.anim.keyframe_insert_menu(type='Location')
          print('REFILL: ***', _fromFrame)
        except Exception as e:
          print('Refill:', e) 
      
      if scn.frame_current==_toFrame:
        break
        
      bpy.ops.screen.keyframe_jump()
      next1 = next2
      next2 = scn.frame_current
    scn.frame_set(_fromFrame)


#na vypisanie frameov di listu
def return_animation_keyframes(frame1, frame2):
  global scn
  ret = list()
  scn.frame_set(frame1-1)
  bpy.ops.screen.keyframe_jump()
  next2 = scn.frame_current
  next1 = next2 - 1 #tymto zarucim, ze na zaciatku nebudu rovnake
  while scn.frame_current <= frame2:
    if next1 != next2:
      ret.append(next2)
      bpy.ops.screen.keyframe_jump()
      next1 = next2
      next2 = scn.frame_current
    else:
      break 
  return ret
    
      
def old_refill_all_intermediate_positions(FrameStart, FrameEnd): #doplni medzipolohy pre vsetky keyframey od keyframeStart po frameEnd
  print ('--------------------')
  print ('REFILL POSITIONS')
  print ('********************')
  global scn
  global armature
  #scn.frame_set(keyFrameStart-1)
  
  #refill_position_between_two_positions(frameFirst, frameSecond, _armature)
  
  global scn
  scn.frame_set(FrameStart-1)
  controll_bone_list = [['Pivot_ruka_R'], ['Pivot_ruka_L'], ['Pivot_noha_R', 'Pivot_noha_L', 'Pivot_noha_prsty_R', 'Pivot_noha_prsty_L', 'Chrbtica1']]
  
  kframes = return_animation_keyframes(FrameStart, FrameEnd)
  
  for kf in kframes:
    for c_b_l in controll_bone_list:
      refill_position_for_bonelist(kf, FrameEnd, c_b_l, armature)
  #bpy.ops.screen.keyframe_jump()
  #keyFrameA = scn.frame_current
  
  
def refill_all_intermediate_positions(): #doplni medzipolohy pre vsetky keyframey od keyframeStart po frameEnd
  print ('--------------------')
  print ('REFILL POSITIONS')
  print ('********************')
  global scn
  global armature
  #scn.frame_set(keyFrameStart-1)
  
  #refill_position_between_two_positions(frameFirst, frameSecond, _armature)
  
  #global scn
  #scn.frame_set(FrameStart-1)
  #controll_bone_list = [['Pivot_ruka_R'], ['Pivot_ruka_L'], ['Pivot_noha_R', 'Pivot_noha_L', 'Pivot_noha_prsty_R', 'Pivot_noha_prsty_L', 'Chrbtica1']]
  
  #kframes = return_animation_keyframes(FrameStart, FrameEnd)
  
  if support_keyframes != []:
    first = support_keyframes[0]
    for i in range(1,len(support_keyframes)):
      second = support_keyframes[i]
      refill_position_between_two_positions(first, second, armature)
      first = second 
  
  if arm_l_keyframes != []:
    first = arm_l_keyframes[0]
    for i in range(1,len(arm_l_keyframes)):
      second = arm_l_keyframes[i]
      refill_position_between_two_positions(first, second, armature)
      first = second
      
  if arm_r_keyframes != []:
    first = arm_r_keyframes[0]
    for i in range(1,len(arm_r_keyframes)):
      second = arm_r_keyframes[i]
      refill_position_between_two_positions(first, second, armature)
      first = second  
      
  print (support_keyframes)
  print (arm_l_keyframes)
  print (arm_r_keyframes)


################################################
### Start DETECTION
###############################################
def return_child_with_name(element, name):
  for e in element.childNodes:
    if e.nodeName == name:
      return e
  return []

  
def detect(start_f, jump_num, tolerance, _armature):
  bpy.ops.object.mode_set(mode='POSE')
  global scn
  count_of_beats = 4
  #scn.frame_set(scn.frame_start)
  scn.frame_set(11)
  controll_bone_list = [['Pivot_ruka_R'], ['Pivot_ruka_L'], ['Pivot_noha_R', 'Pivot_noha_prsty_R', 'Chrbtica1', 'Pivot_noha_L', 'Pivot_noha_prsty_L', 'Chrbtica1']]
  list_of_loc_dict = list()
  
  dc = minidom.Document()
  laban = dc.createElement('laban')
  dc.appendChild(laban)
  
  attribute = dc.createElement('attribute')
  laban.appendChild(attribute)
  
  time = dc.createElement('time')
  attribute.appendChild(time)
  
  beat = dc.createElement('beat')
  beat_type = dc.createElement('beat-type')
  time.appendChild(beat)
  time.appendChild(beat_type)
  
  beat.appendChild(dc.createTextNode(str(count_of_beats)))
  beat_type.appendChild(dc.createTextNode(str(4)))
  #------
  
  notation = dc.createElement('notation')
  laban.appendChild(notation)
  #------
  
  scn.frame_set(start_f)
  num = 0
  while scn.frame_current<=scn.frame_end:
    myBeat = round(((scn.frame_current - start_f -jump_num)/jump_num) % count_of_beats)
    if (myBeat == 0):
      num = num+1
      measure = dc.createElement('measure')
      measure.setAttribute("num", str(num))
      notation.appendChild(measure)
    if num==0:
      measure = dc.createElement('measure')
      measure.setAttribute("num", str(num))
      notation.appendChild(measure)
      
    for c_b_l in controll_bone_list:
      list_of_loc_dict.append(find_position_for_bones_list(c_b_l, scn.frame_current, _armature))
      
    for l in list_of_loc_dict:
      if (l['max_key'] != '?'):
        d = make_dictionary_from_my_string(l['max_key'])
        if (d['bodypart'] == 'Arm_R' or d['bodypart'] == 'Arm_L'):
          bp = dc.createElement('arm')
          bp.setAttribute("duration", "1")
          if num == 0:
            bp.setAttribute("ticknum", str(1))
          else:
            bp.setAttribute("ticknum", str(myBeat+1))
          
          direc = dc.createElement('direction')
          lev = dc.createElement('level')
          direc.appendChild(dc.createTextNode(d['direction']))
          lev.appendChild(dc.createTextNode(d['level']))
          bp.appendChild(direc)
          bp.appendChild(lev)
          if (d['bodypart'] == 'Arm_R'):
            sideR = return_child_with_name(measure, 'right')
            if sideR == []:
              sideR = dc.createElement('right')
            sideR.appendChild(bp)
            measure.appendChild(sideR)
          if (d['bodypart'] == 'Arm_L'):
            sideL = return_child_with_name(measure, 'left')
            if sideL == []:
              sideL = dc.createElement('left')
            print("SIDEL", sideL.childNodes)
            sideL.appendChild(bp)
            measure.appendChild(sideL)
          #bp = dc.createElement(d['bodypart'])
          #dir = dc.createElement(d['direction'])
          #lev = dc.createElement(d['level'])
        else:
          if (d['bodypart'] == 'Support_R' or d['bodypart'] == 'Support_L'):
            side = dc.createElement('support')
            if (d['bodypart'] == 'Support_R'):
              side.setAttribute("side", "right")
            if (d['bodypart'] == 'Support_L'):
              side.setAttribute("side", "left")    
            
            side.setAttribute("duration", "1")
            if num == 0:
              side.setAttribute("ticknum", str(1))
            else:
              side.setAttribute("ticknum", str(myBeat+1))
            
            direc = dc.createElement('direction')
            lev = dc.createElement('level')
            direc.appendChild(dc.createTextNode(d['direction']))
            lev.appendChild(dc.createTextNode(d['level']))
            side.appendChild(direc)
            side.appendChild(lev)
             
            measure.appendChild(side)
          if (d['bodypart'] == 'Support'):
            side1 = dc.createElement('support')
            side2 = dc.createElement('support')
            
            side1.setAttribute("side", "right")
            side1.setAttribute("duration", "1")
            if num == 0:
              side1.setAttribute("ticknum", str(1))
            else:
              side1.setAttribute("ticknum", str(myBeat+1))
            side2.setAttribute("side", "left")
            side2.setAttribute("duration", "1")
            if num == 0:
              side2.setAttribute("ticknum", str(1))
            else:
              side2.setAttribute("ticknum", str(myBeat+1))
            
            arrDir = []; #prazdne pole
            arrDir = d['direction'].rsplit('_')
            arrLev = []; #prazdne pole
            arrLev = d['level'].rsplit('_')
            
            direc1 = dc.createElement('direction')
            lev1 = dc.createElement('level')
            direc1.appendChild(dc.createTextNode(arrDir[0]))
            lev1.appendChild(dc.createTextNode(arrLev[0]))
            
            side1.appendChild(direc1)
            side1.appendChild(lev1)
            
            direc2 = dc.createElement('direction')
            lev2 = dc.createElement('level')
            direc2.appendChild(dc.createTextNode(arrDir[1]))
            lev2.appendChild(dc.createTextNode(arrLev[1]))
            
            side2.appendChild(direc2)
            side2.appendChild(lev2)
            
            measure.appendChild(side1)
            measure.appendChild(side2)
            
            
    
    list_of_loc_dict = []
      
      
    scn.frame_set(scn.frame_current + jump_num)

   
  myfile = open(scn['MyDetectPath'], 'w')
  #"D:\\python and xml pokus\\march_and_hand.xml"
  myfile.write(dc.toxml())   
  
##############################################
### End DETECTION
##############################################

  
def run(g_koef):
  global global_koef
  global_koef = g_koef
  
  global animation_shifting
  global scn
  animation_shifting = global_koef * beats_in_one_bar - scn['MyStartFrame']
                  
  print('--------------------------')
  #xmlfile = "D:\\python and xml pokus\\march.xml"
  #xmlfile = "D:\\python and xml pokus\\hand_moving.xml"
  #xmlfile = "D:\\python and xml pokus\\march_and_hand.xml"
  xmlfile = scn['MyOwnPath']
  positions_file = "D:\\python and xml pokus\\positions_ik03.xml"
  intermediate_positions_file = "D:\\python and xml pokus\\positions_intermediate_ik.xml"
  
  global positions
  positions = load_positions_from_xml(positions_file)
  #print(positions['Arm_R']['Right']['L'])
  
  global intermediate_positions
  intermediate_positions = load_positions_from_xml(intermediate_positions_file)
  #print ('INTER:', intermediate_positions)
    
  #nacitanie xml
  try:
    laban_doc = minidom.parse(xmlfile)
    print ('Success load LabanXML file!') 
  except:
    print ('Can\'t parse LabanXML file!')
    #TODO - upozornenie v Blenderi
    return False; 
  
  scn.frame_set(scn.frame_start)#scn.frame_current = 0
  start = scn.frame_start
  end = scn.frame_end
  #deleteKeyFrames(start, end)
  #TODO - dorob fciu pre vratenie kostry do rest pozy
  
  name_of_selected_object = bpy.context.active_object.name #vyberieme objekt, ktory je oznaceny
  global armature
  armature = bpy.data.objects[name_of_selected_object]
  
  try: #pokusime sa aplikovat pohyby z xml na oznaceny objekt
    bpy.ops.object.mode_set(mode='POSE')
    bpy.ops.pose.group_deselect() #MUSI BYT ABY SOM MOHOL UKLADAT KEY FRAMEy
    bpy.ops.pose.group_select()  #MUSI BYT ABY SOM MOHOL UKLADAT KEY FRAMEy
    #bpy.ops.anim.keyframe_insert_menu(type='LocRot') #vlozim key frame hned na zaciatku (aby som si zapamatal pociatok)
    
    #kedze je uspesne nacitany xml subor, tak mozeme parsovat
    #global armature  
    parse_document(armature, laban_doc)
    #print('JANKO @@@')
  except Exception as e:
    print (e)
    print('Warning: You must select armature(skeleton), that you want animate!')
    return False
    

  #nastavim koniec animacie
  scn.frame_end = scn['MyStartFrame'] + global_koef*bar*beats_in_one_bar + beats_in_one_bar #nastavim zaver animacie vypocitany podla barova beatov     

  print (support_keyframes)
  print (arm_l_keyframes)
  print (arm_r_keyframes)
      
  return True
      

################################ 
#       GUI interface
#################################

# Layout panel
def initSceneProperties(scn):
  #pre deletinng keyframes and rotations
  bpy.types.Scene.MyStartKeyFrameDeleting = IntProperty(
    name = "from frame:", 
    description = "Enter start frame value for deleting keyFrames",
    default = 1)
  scn['MyStartKeyFrameDeleting'] = 1
  
  bpy.types.Scene.MyEndKeyFrameDeleting = IntProperty(
    name = "to frame", 
    description = "Enter end frame value for deleting keyFrames",
    default = scn.frame_end)
  scn['MyEndKeyFrameDeleting'] = scn.frame_end

  #pre Laban animation
  bpy.types.Scene.MyStartFrame = IntProperty(
    name = "Starting frame", 
    description = "Enter start frame of Laban animation",
    default = 1)
  scn['MyStartFrame'] = 1
  
  bpy.types.Scene.MySpeed = IntProperty(
    name = "Animation speed", 
    description = "Enter a natural number greather than 4 (bigger number means slower animation)",
    default = 4,
    min = 4)
  scn['MySpeed'] = 4
  
  bpy.types.Scene.MyOwnPath = StringProperty(name="file path",
    attr="custompath",# this a variable that will set or get from the scene
    description="File path of LabanXML file",
    maxlen= 1024,
    subtype='FILE_PATH',
    default= '')
  #scn['MyOwnPath'] = "C:\\tmp\\"
  scn['MyOwnPath'] = "D:\\python and xml pokus\\"
  
  #pre detekciu
  bpy.types.Scene.DetectStartFrame = IntProperty(
    name = "Starting frame", 
    description = "Enter start frame for detection of Laban movement",
    default = 1)
  scn['DetectStartFrame'] = scn.frame_start
  
  bpy.types.Scene.MyBeat = IntProperty(
    name = "Beat duration", 
    description = "Enter a natural number for durtion of one beat",
    default = 4,
    min = 1)
  scn['MyBeat'] = 4
  
  bpy.types.Scene.MyDetectPath = StringProperty(name="file path",
    attr="custompath",# this a variable that will set or get from the scene
    description="File path of detected LabanXML file",
    maxlen= 1024,
    subtype='FILE_PATH',
    default= '')
  #scn['MyOwnPath'] = "C:\\tmp\\"
  scn['MyDetectPath'] = "D:\\python and xml pokus\\detect.xml"
 
 
# Menu in window region, bone context
class UIPanel(bpy.types.Panel):
    bl_label = "LabanXML Movement"
    #bl_space_type = "VIEW_3D"
    #bl_region_type = "TOOL_PROPS"
    bl_space_type = "PROPERTIES"
    bl_region_type = "WINDOW"
    bl_context = "bone"
 
    def draw(self, context):
        layout = self.layout
        scn = context.scene
        
        layout.label("Deleting Keyframes:")
        row = layout.row(align=True)
        row.alignment = 'EXPAND'
        row.prop(scn, 'MyStartKeyFrameDeleting', icon='BLENDER', toggle=True)
        row.prop(scn, 'MyEndKeyFrameDeleting')
        row = layout.row()
        column = row.column()
        split = row.split()
        split.operator("deleting_key_frames.button")
        
        layout.label("Clear rotations on selected armature:")
        row = layout.row()
        column = row.column()
        split = row.split()
        split.operator("clear_loc.button")
        
        layout.label("--------------------------------------------------------------------")
        layout.label("Laban animation:")
        layout.prop(scn, 'MyStartFrame', icon='BLENDER', toggle=True)
        layout.prop(scn, 'MySpeed')
        #layout.prop(scn, 'MyFloat')
        layout.label("Choose LabanXML file:")
        layout.prop(context.scene, 'MyOwnPath')
        #layout.prop(scn, 'MyBool')
        #layout.prop(scn, 'MyEnum')
        #layout.prop(scn, 'MyString')
        layout.label("Apply LabanXML:")
        layout.operator("idname_must.be_all_lowercase_and_contain_one_dot")
        
        row = layout.row()
        #column = row.column()
        split = row.split()
        split.label("Refill positions:")
        split.operator("refill_positions.button")
        
        layout.label("--------------------------------------------------------------------")
        layout.label("Laban detection:")
        layout.prop(scn, 'DetectStartFrame')
        layout.prop(scn, 'MyBeat')
        layout.prop(context.scene, 'MyDetectPath')
        layout.label("Detect an create XML file:")
        layout.operator("detect_laban.button")
 
# Buttony
class OBJECT_OT_ClearKeyframesButton(bpy.types.Operator):
    bl_idname = "deleting_key_frames.button"
    bl_label = "Delete Keyframes"
 
    def execute(self, context):
        deleteKeyFrames(scn['MyStartKeyFrameDeleting'], scn['MyEndKeyFrameDeleting'])
        return{'FINISHED'}

class OBJECT_OT_ClearLocButton(bpy.types.Operator):
    bl_idname = "clear_loc.button"
    bl_label = "Clear changes"
 
    def execute(self, context):
        clear_location_on_armature(bpy.context.active_object.name)
        return{'FINISHED'} 

 
class OBJECT_OT_PrintPropsButton(bpy.types.Operator):
    bl_idname = "idname_must.be_all_lowercase_and_contain_one_dot"
    bl_label = "Apply"
 
    def execute(self, context):
        run(scn['MySpeed'])
        return{'FINISHED'}  
        

class OBJECT_OT_PrintPropsButton(bpy.types.Operator):
    bl_idname = "refill_positions.button"
    bl_label = "Refill positions"
 
    def execute(self, context):
        #run(scn['MySpeed'])
        try:
          #refill_all_intermediate_positions(scn['MyStartFrame'], scn.frame_end)
          refill_all_intermediate_positions()
          print('Succesfull refilling intermediate positions')
        except Exception as e:
          print('Function refill_all_intermediate_positions was not successfull:', e)
        return{'FINISHED'}
        

class OBJECT_OT_PrintPropsButton(bpy.types.Operator):
    bl_idname = "detect_laban.button"
    bl_label = "Detect"
    global armature
    global scn
 
    def execute(self, context):
        #run(scn['MySpeed'])
        detect(scn['DetectStartFrame'], scn['MyBeat'], 2, armature)
        return{'FINISHED'}                            
        

#####################################
#     spusti sa po spusteni skriptu
####################################
if __name__ == "__main__":
  #main()
  initSceneProperties(bpy.context.scene)
  # Registracia GUI
  bpy.utils.register_module(__name__)
  
  name_of_selected_object = bpy.context.active_object.name #vyberieme objekt, ktory je oznaceny
  global armature
  armature = bpy.data.objects[name_of_selected_object]
   